Liferay.Loader.define("frontend-js-web@4.0.47/liferay/util/get_portlet_id", ['module', 'exports', 'require'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = getPortletId;

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */

    /**
     * Returns the portlet Id extracted from the provided portletId query parameter
     * @param {!string} portletId The portletId query parameter to extract the portletId from in the form of `_p_p_id_portletId_`
     * @return {string} Portlet ID
     * @review
     */
    var REGEX_PORTLET_ID = /^(?:p_p_id)?_(.*)_.*$/;

    function getPortletId(portletId) {
      return portletId.replace(REGEX_PORTLET_ID, '$1');
    }
    //# sourceMappingURL=get_portlet_id.js.map
  }
});
//# sourceMappingURL=get_portlet_id.js.map